gLevelValues.exitCastleLevel = 16
gLevelValues.exitCastleArea = 1
gLevelValues.exitCastleWarpNode = 10

gBehaviorValues.KoopaBobAgility = 4.0

gBehaviorValues.MipsStar1Requirement = 0
gBehaviorValues.MipsStar2Requirement = 30

gBehaviorValues.ToadStar1Requirement = 0
gBehaviorValues.ToadStar2Requirement = 25
gBehaviorValues.ToadStar3Requirement = 35

gLevelValues.pssSlideStarTime = 630

gLevelValues.metalCapDurationCotmc =1
gLevelValues.wingCapDurationTotwc = 1
gLevelValues.vanishCapDurationVcutm = 1

gBehaviorValues.trajectories.KoopaBobTrajectory = get_trajectory('KoopaBoB_path')
gBehaviorValues.trajectories.BowlingBallBobTrajectory = get_trajectory('bob_seg7_metal_ball_path0_RM2C_path')
gBehaviorValues.trajectories.PlatformRrTrajectory = get_trajectory("rr_seg7_trajectory_0702EC3C_RM2C_path")

local L_Cam = false
local Lives = false

---@param m MarioState
local function mario_update(m)

    ---- Camera ----

    if camera_config_is_free_cam_enabled() then return end
    if m.playerIndex ~= 0 then return end

    local swimFly = (m.action & ACT_FLAG_SWIMMING_OR_FLYING) ~= 0

    if (m.controller.buttonPressed & L_TRIG) ~= 0 and swimFly then
        L_Cam = not L_Cam
    end

    if (gLakituState.mode == 3 or gLakituState.mode == 8)
       and not swimFly
       and m.action == ACT_EMERGE_FROM_PIPE then
       gLakituState.mode = CAMERA_MODE_ROM_HACK
    end

    if L_Cam and swimFly then
        if gLakituState.mode == 3 or gLakituState.mode == 8 then
            gLakituState.mode = CAMERA_MODE_ROM_HACK
        end
    end

    ---- Key and Exit Star Cutscenes ----

    if m.area.camera.cutscene == CUTSCENE_KEY_DANCE
        or m.area.camera.cutscene == CUTSCENE_DANCE_FLY_AWAY
            or m.area.camera.cutscene == CUTSCENE_DANCE_ROTATE then
        m.area.camera.cutscene = CUTSCENE_DANCE_DEFAULT
    end

    ---- Force Stay in Level Stars (just to be sure) ----

    if (m.action == ACT_STAR_DANCE_EXIT) or
            (m.action == ACT_STAR_DANCE_WATER) then
        m.actionArg = 1
    end

    ---- Lives and Fall Damage ----

    m.peakHeight = m.pos.y

        if not Lives then
            Lives = true
        m.numLives = 10
    end
end

    ---- No Exit Key Action (unused) ----

    --[[local np = gNetworkPlayers[0]
    if np.currLevelNum == LEVEL_BOWSER_1 or np.currLevelNum == LEVEL_BOWSER_2 then
        if (m.action == ACT_STAR_DANCE_EXIT) or
            (m.action == ACT_STAR_DANCE_WATER) then
            m.actionArg = 1
        end
    end--]]

    ---- Elevator Fix ----

local function mario_on_set_action(m)
	if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or
		m.action == ACT_TRIPLE_JUMP or m.action == ACT_SPECIAL_TRIPLE_JUMP or
		m.action == ACT_STEEP_JUMP or m.action == ACT_SIDE_FLIP or
		m.action == ACT_BACKFLIP or m.action == ACT_LONG_JUMP or
		m.action == ACT_RIDING_SHELL_JUMP then 
		if m.pos.y < m.floorHeight - 6 then
			m.pos.y = m.pos.y +5
			m.vel.y = m.vel.y +11
		end
	end
end

    ---- Fix Collision ----

local function fix_col()

    local np = gNetworkPlayers[0]
    gLevelValues.fixCollisionBugs = false
    if np.currLevelNum == LEVEL_CASTLE_GROUNDS then
        gLevelValues.fixCollisionBugs = true
        gLevelValues.fixCollisionBugsRoundedCorners = false
        gLevelValues.fixCollisionBugsFalseLedgeGrab = false
        gLevelValues.fixCollisionBugsGroundPoundBonks = false
        gLevelValues.fixCollisionBugsPickBestWall = false
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)
hook_event(HOOK_UPDATE, fix_col)